/* $Id: tree.cc,v 1.7 2001/05/14 06:57:32 ltd Exp $ */
#include <cstdio>
#include <std.h>
#include <func/apt.h>
#include <list/pkgtree.h>
#include <list/screens.h>
#include <interface/deityui.h>
#include "tree.h"

void depend_tree_expand(PackageTree::Item * Master, PackageTree &tree)
{
	PackageTree::Item * mal;

	pkgCache::DepIterator D;
	pkgCache::VerIterator V = Master->Version();

	(int) Master->State |= PackageTree::Item::Expanded;
	
	for (D = V.DependsList(); D.end() == false; D++)
	{
		mal = tree.add(&Master->child, Master);

		if (strcmp(Master->TargetPkg.Name(), D.TargetPkg().Name()) == 0)
			(int) mal->State |= PackageTree::Item::Expanded;

		mal->TargetPkg = D.TargetPkg();
		mal->Extra = new pkgCache::DepIterator(D);
		mal->increment = Master->increment + 1;
		mal->Type = PackageTree::Item::Dep;
	}
}

void depend_tree_destruct(PackageTree::Item *x, PackageTree &tree)
{
	(int) x->State &= ~PackageTree::Item::Expanded;

	if (x->child)
		tree.FreeTree(x->child);
}
