/* $Id: ops.cc,v 1.10 2001/05/14 15:07:02 ltd Exp $ */
#include <std.h>
#include <ops.h>

#include <parsers/strutl.h>
#include <func/apt.h>
#include <func/keys.h>
#include <func/pkgchecks.h>
#include <list/screens.h>
#include <interface/deityui.h>
#include <backend/acquire.h>

bool TextOp::CacheInit;
bool TextOp::BrokenFix;
unsigned TextOp::opRealCount;

void TextOp::PrepareOp(opType currentOp, string pkgstr)
{
	if (CacheInit == false)
	{
		// Create apt UI here
		//CaptUI = DeityUI::CreateInterface(NULL);

		Cache = new deitypkgcache;
		CacheInit = true;

		BrokenFix = false;
		if ((*Cache)->BrokenCount() != 0)
			BrokenFix = true;
	}

	bool Remove;

	if (currentOp == remove)
		Remove = true;

	else if (currentOp == purge)
	{
		Remove = true;
		_config->Set("APT::Console::Purge", "true");
	}
	else
		Remove = false;
		
	pkgCache::PkgIterator Pkg = (*Cache)->FindPkg(pkgstr);

	if (Pkg.end() == true)
	{
		const char *P;
		for (P = pkgstr.c_str(); *P != 0; P++)
			if (*P == '.' || *P == '?' || *P == '*')
				break;

		if (*P == 0)
		{
			CaptUI->ShowDialog("Not found",
				"\n Couldn't find package $2#%s$! in the package cache \n", pkgstr.c_str());
			return;
		}

		regex_t Pattern;
		
		if (regcomp(&Pattern, pkgstr.c_str(), REG_EXTENDED | REG_ICASE | REG_NOSUB) != 0)
			return (void) _error->Error("Regex compilation error");

		bool Hit = false;
		for (pkgCache::PkgIterator I = (*Cache)->PkgBegin(); I.end() == false; I++)
		{
			if (regexec(&Pattern, I.Name(), 0, 0, 0) != 0)
				continue;

			//Hit |= TryToInstall(I, *Cache, Cache->Resolver(), Remove, BrokenFix, opRealCount);

			if (Hit == false) CURRENTSCR->Redraw();
		}
		regfree(&Pattern);

		if (Hit == false)
			CaptUI->ShowDialog("Match not found",
				"\n Couldn't match regexp '$2#%s$!' in the cache \n", pkgstr.c_str());
	}
//	else
	//	TryToInstall(Pkg, *Cache, Cache->Resolver(), Remove, BrokenFix, opRealCount);
}
	
int search_string(const char *haystack, char *needle, unsigned long options, regex_t * rectx)
{
   if (options & SEARCH_REGEX) 
   {
       return (int)!regexec(rectx, haystack, 0, NULL, 0);
   } 
   else if (options & SEARCH_CASE) 
   {
       int ret;
       char * hay = strdup(haystack);

       // needle must already be lower-case
       strlower(hay);
       ret = (int)strstr(hay, needle); 

       free(hay);
       return ret;
   } 
   else 
   {
       return (int)strstr(haystack, needle);
   }   
}
