// $Id: std.h,v 1.10 2001/05/15 08:32:58 ltd Exp $
#ifndef std_H
#define std_H

#include "config.h"
#include "func/debug.h"
#include <libio.h>

#include <iostream.h>
#include <string.h>
#include <list.h>

#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <assert.h>

#include <apt-pkg/configuration.h>
#include <apt-pkg/progress.h>
#include <apt-pkg/sourcelist.h>
#include <apt-pkg/depcache.h>
#include <apt-pkg/init.h>
#include <apt-pkg/pkgcachegen.h>
#include <apt-pkg/pkgrecords.h>
#include <apt-pkg/cachefile.h>
#include <apt-pkg/error.h>
#include <apt-pkg/acquire-item.h>
#include <apt-pkg/acquire-worker.h>
#include <apt-pkg/strutl.h>
#include <apt-pkg/dpkgpm.h>
#include <apt-pkg/algorithms.h>

class DeityUI;

extern char const *internal_version;
extern char *search_pattern;

extern void deity_clean_exit(void);
extern DeityUI *CaptUI;

#define DEBUGEXIT(x) { if (CaptUI) delete CaptUI; fprintf(stderr, "Exit: \"%s\"\n", x); exit(0); }

#define myassert(truth, text) if ((truth) == false) { if (CaptUI) delete CaptUI; fprintf(stderr, "Assertion failure: %s\n", text);}

#define CURRENTSCR (CaptUI->scrlst.Current())

#ifndef NULL
#define NULL 0
#endif

#define INFO_ERROR	0
#define INFO_WARN	1
#define INFO_DEBUG	5
#define INFO_VERBOSE	20

#ifdef DEBUG
#define INFO(level, fmt, args...)					\
	debug_printf(level, fmt, ##args)
#define ASSERT(cond)	do { if (!(cond)) { fprintf(stderr, "Assertion (%s) failed at %s:%d\n", #cond, __FILE__, __LINE__); abort(); } } while(0)
#define NOTREACHED(fmt...)	do { fprintf(stderr, fmt); fprintf(stderr, " at %s:%d\n", __FILE__, __LINE__); abort(); } while (0)
#else
#define INFO(level, fmt, args...)	/* nothing */
#define ASSERT(cond)
#define NOTREACHED(fmt...)
#endif

#endif /* std_H */
