/* $Id: sortui.cc,v 1.7 2001/02/26 01:36:18 tausq Exp $ */
#include <std.h>
#include "cursesui.h"
#include "wrappers.h"
#include "sortui.h"
#include <interface/deityui.h>
#include <list/screens.h>
#include "colors.h"
#include <ncurses.h>

namespace CursesSort {

bool SortInsert(Screen *Owner, UniqueWindow *Popup, bool Append = false)
{
	int I;
	SortOrderList::SortIterator S = Owner->Packages->Sorting->ListEnd();

	curs_set(1);
	
	if (Append == false)
	{
		for (I = 0; I <= 10; I++)
		{
			wmove(Popup->body(), I, 0);
			wclrtoeol(Popup->body());
		}

		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_MAGENTA, COLOR_BLUE)|A_BOLD);
		mvwprintw(Popup->body(), 1, 2, "Please enter the number of the sort method that");
		mvwprintw(Popup->body(), 2, 2, "you would like to insert a new entry /before/.");

		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
		mvwprintw(Popup->body(), 4, 7, "Insert before ('Q' aborts): ");

		Popup->Refresh();

		while (1)
		{
			char c = wgetch(Popup->body());

			if (c == 'q' || c == 'Q')
			{
				curs_set(0);
				return false;
			}

			c -= 48;

			for (S = Owner->Packages->Sorting->ListBegin(); S.end() == false; S++)
				if (S.seq() == (unsigned)c)
					break;

			if (S.end() == true)
			{
				wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
				mvwprintw(Popup->body(), 6, 7, "That method doesn't exist!");
				wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
			}
			else
				break;
		}
	}

	for (I = 0; I <= 10; I++)
	{
		wmove(Popup->body(), I, 0);
		wclrtoeol(Popup->body());
	}

	wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_MAGENTA, COLOR_BLUE)|A_BOLD);
	CursesUI::mv_printw_color(Popup->body(), 1, 0, " %s ($3#yellow$! = installed, $7#white$! = available):", Append == true ? "Append" : "Insert");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Section))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 3, 0, "   T  ==  Type/section (x11, admin, utils, etc)");
	
	if (Owner->Packages->Sorting->Exists(SortOrderList::PkgName))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 4, 0, "   N  ==  Name (alphabetically)");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Priority))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 5, 0, "   P  ==  Priority (needworthyness)");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Status))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 6, 0, "   S  ==  Status (installed / upgraded)");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Size))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 7, 0, "   A  ==  Archive size (download)");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Instsize))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 8, 0, "   I  ==  Installed size (unpacked)");

	if (Owner->Packages->Sorting->Exists(SortOrderList::Suite))
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_YELLOW, COLOR_BLUE));
	else
		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 8, 0, "   U  ==  Suite (main, contrib, etc");

	wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 9, 0, "   Q  ==  Go back [Exit]");

	wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);

	mvwprintw(Popup->body(), 6, 42, "Your choice: ");

	Popup->Refresh();

	bool exitloop = false, listchanged = false;

	while (exitloop == false)
	{
		char c = wgetch(Popup->body());

		switch (c)
		{
			case 'q':
			case 'Q':
				curs_set(0);
				return listchanged;

			case 't':
			case 'T':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Section))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Section);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Section);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 'n':
			case 'N':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::PkgName))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::PkgName);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::PkgName);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 'p':
			case 'P':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Priority))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Priority);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Priority);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 's':
			case 'S':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Status))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Status);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Status);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 'a':
			case 'A':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Size))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Size);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Size);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 'i':
			case 'I':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Instsize))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Instsize);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Instsize);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			case 'u':
			case 'U':
				if (!Owner->Packages->Sorting->Exists(SortOrderList::Suite))
				{
					if (Append == true)
						Owner->Packages->Sorting->Push(SortOrderList::Suite);
					else
						Owner->Packages->Sorting->Insert(S, SortOrderList::Suite);
					exitloop = true;
					listchanged = true;
				}
				else
				{
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
					mvwprintw(Popup->body(), 4, 42, "Already exists!");
					wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				}
				break;

			default:
				wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);
				mvwprintw(Popup->body(), 4, 42, "               ");
				mvwprintw(Popup->body(), 4, 42, "Bad key!");
				wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
				break;
		}

		wmove(Popup->body(), 6, 55);
		Popup->Refresh();
	}

	curs_set(0);

	return listchanged;
}

bool SortDelete(Screen *Owner, UniqueWindow *Popup)
{
	int I;

	for (I = 0; I <= 10; I++)
	{
		wmove(Popup->body(), I, 0);
		wclrtoeol(Popup->body());
	}
	
	curs_set(1);

	char c;

	SortOrderList::SortIterator S;

	while (1)
	{
		mvwprintw(Popup->body(), 5, 12, "('Q' to exit)");
		mvwprintw(Popup->body(), 4, 12, "Delete method number: ");

		Popup->Refresh();

		c = wgetch(Popup->body());

		if (c == 'q' || c == 'Q')
		{
			curs_set(0);
			return false;
		}
			
		if (c >= 49 && c <= 58)
			c -= 48;
		else
			c = -1;

		bool exitloop = false;

		S = Owner->Packages->Sorting->ListBegin();

		while (S.end() != true)
		{
			if (S.seq() == (unsigned) c)
			{
				exitloop = true;
				break; 
			}
			S++;
		}

		if (exitloop == true)
			break;

		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_RED, COLOR_BLUE)|A_BOLD);

		mvwprintw(Popup->body(), 2, 6, "Error! Can't delete a nonexistant method.");

		wattrset(Popup->body(), CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
	}

	Owner->Packages->Sorting->remove(S);	

	curs_set(0);

	return true;
}

bool SortModify(Screen *Owner, UniqueWindow *Popup)
{
	return false;
}

/*
 * Note - memory is allocated, that must be freed.
 */
char *SortToStr(SortOrderList::method_t ThisMethod)
{
	char *str = (char *)malloc(100);

	switch (ThisMethod)
	{
		case SortOrderList::None:
			break;
		case SortOrderList::Section:
			strcpy(str, "type/section");
			break;
		case SortOrderList::PkgName:
			strcpy(str, "name, alphabetically");
			break;
		case SortOrderList::Priority:
			strcpy(str, "install-need priority");
			break;
		case SortOrderList::Status:
			strcpy(str, "installed/upgraded status");
			break;
		case SortOrderList::Size:
			strcpy(str, "archive size");
			break;
		case SortOrderList::Instsize:
			strcpy(str, "installed size");
			break;
		case SortOrderList::Suite:
			strcpy(str, "suite");
			break;
		default:
			strcpy(str, "");
			break;
	}

	return str;
}

}; // namespace
