/* $Id: filteredit.h,v 1.1 2001/03/04 01:02:14 tausq Exp $ */
#ifndef _gtkui_srcedit_H
#define _gtkui_srcedit_H

#include "gtkui.h"
#include <list/filters.h>

#define NUM_FILTER_TYPES 7

class GtkUI::FilterEditor {
	GtkUI &ui;

	GtkWidget *dialog;
	GtkWidget *baselist, *targetlist;
	GtkWidget *filtertext;

	Filter::Target filters;

	int baserow, targetrow;
	bool cancelled;
	bool baseselected[NUM_FILTER_TYPES];
	bool targetselected[NUM_FILTER_TYPES];

	GtkWidget *CreateWidget();
	void UpdateLists();

	// static event handlers
	static void DoOK(GtkWidget *, gpointer);
	static void DoCancel(GtkWidget *, gpointer);
	static void SelectRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void UnselectRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void DoAdd(GtkWidget *, gpointer);
	static void DoRemove(GtkWidget *, gpointer);

	/*
	static void UpdateDisplay(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	*/

public:
	FilterEditor(GtkUI &);
	~FilterEditor();

	bool Run();
	void GetFilter(char *&filtertext, Filter::Target &target);
};

#endif
