/* $Id: gtkui.h,v 1.14 2001/05/14 15:07:02 ltd Exp $ */
#ifndef _gtkui_H
#define _gtkui_H

#include <backend/acquire.h>
#include <list/screens.h>
#ifdef USE_DEBCONF
#include <interface/deityui.h>
#endif

#include <gtk/gtk.h>

class GtkUI : public DeityUI {
	class Screen;
	class PkgTreeWidget;
	class ProgressBar;
	class About;
	class SortUI;
	class SrcEditor;
	class FilterEditor;
	class AcquireUI;
#ifdef USE_DEBCONF
	class DebConfGUI;
#endif
	class pkgMgrInt;

	friend class Screen;
	friend class AcquireUI;

protected:
	
	pkgAcquireBackend *fetcher;
	GtkWidget *splashwin;
	pid_t debconfpid;

	void ShowSplash();
	void HideSplash();

	void CreateKeyInterface(GtkWidget *widget);
	static gint signalKeyPress(GtkWidget *widget, GdkEventKey *event, gpointer data);

	static gboolean _ProcessMsg(GIOChannel *src, GIOCondition cond, gpointer data);
#ifdef USE_DEBCONF
	static gboolean _ProcessDebConfMsg(GIOChannel *src, GIOCondition cond, gpointer data);
#endif

	void PrepareForInstall() {};
	void RecoverFromInstall() {};
	
	// Standard termination for dialogs
	static gint DeleteEvent(GdkEvent *, gpointer);
	static void WidgetDestroyEvent(GdkEvent *, gpointer);
	static void Destroy();
	
public:
	GtkUI();
	~GtkUI();
	
	int Run();
	void Startup();
	void Shutdown();

	void Restart() {};

	void Modal(::Screen *);
	
	virtual void WaitForFetch(pkgAcquireBackend *, int fd);
#ifdef USE_DEBCONF
	virtual void WaitForDebConf(int fd);
#endif

	virtual void TextEntry(char *, char **);
	unsigned char ShowDialog(char *, char *, ...);
	bool FilterSelect(char **, Filter::Target *);
	
	void DrawTrees();
	void DrawScreens();

	::Screen *CreateScreen(::Screen::ScrInit, ::Screen::ScrFunc);
	OpProgress *CreateProgressBar();
	DeityUI::pkgMgrInt *CreatePMI();
	void CreateAcquireUI();
#ifdef USE_DEBCONF
	void CreateDebConfGUI();
#endif
};

#endif // _gtkui_H
