/* $Id: util.cc,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#include <std.h>
#include <gtk/gtk.h>
#include "util.h"

GdkPixmap *GtkUtil::PixmapFromXPM(char **xpm_data, GdkColor *trans_color = NULL)
{
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	return gdk_pixmap_colormap_create_from_xpm_d(NULL, cmap, &mask, trans_color, (gchar **)xpm_data); 
}

GtkWidget *GtkUtil::ImageFromXPM(char **xpm_data, GdkColor *trans_color = NULL)
{
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, cmap, &mask, trans_color, (gchar **)xpm_data); 

	if (pixmap == NULL) return NULL;
	return gtk_pixmap_new(pixmap, mask);
}

GdkPixmap *GtkUtil::PixmapFromXPMFile(const char *fn, GdkColor *trans_color = NULL)
{
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	return gdk_pixmap_colormap_create_from_xpm(NULL, cmap, &mask, trans_color, fn);
}

GtkWidget *GtkUtil::ImageFromXPMFile(const char *fn, GdkColor *trans_color = NULL)
{
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	pixmap = gdk_pixmap_colormap_create_from_xpm(NULL, cmap, &mask, trans_color, fn);

	if (pixmap == NULL) return NULL;
	return gtk_pixmap_new(pixmap, mask);
}
