/* $Id: pkgtreeitem.h,v 1.4 2001/05/14 06:57:32 ltd Exp $ */
#ifndef _pkgtreeitem_H
#define _pkgtreeitem_H

class PackageTree;

struct PackageTree::Item
{
	enum pkgState { None = 0, Expanded = (1 << 0), Matched = (1 << 1), Hidden = (1 << 2) };
	enum pkgType { Pkg, Dep, Div_Sect, Div_Pri, Div_State, Div_Custom, Div_Suite };

	int increment;		// How far this pkg increments in dependency
	void *Extra;		// A pointer for other uses ...

	pkgCache::PkgIterator TargetPkg;
	//pkgCache::VerIterator TargetVer;

	pkgState State;
	pkgType Type;

	// Behave like a pkgiterator
	inline operator pkgCache::PkgIterator & () { return TargetPkg; };

	// Access the target version for this package
	inline pkgCache::VerIterator Version() { return TargetPkg.VersionList(); };
	inline pkgCache::VerIterator Candidate() { return (*Cache)[TargetPkg].CandidateVerIter(*Cache); };
	inline pkgCache::VerIterator InstVersion() { return (*Cache)[TargetPkg].InstVerIter(*Cache); };

	// Common flag checking functions
	inline bool IsPackage() { return Type == Pkg; };
	inline bool IsDivider() { return (Type == Pkg || Type == Dep) ? false : true; };
	inline bool IsDepend() { return Type == Dep; };
	inline bool IsMatched() { return State & Matched; };
	inline bool IsExpanded() { return State & Expanded; };
	inline bool IsHidden() { return State & Hidden; };

	struct PackageTree::Item *next, *prev, *child, *parent;
};

#endif // _pkgtreeitem_H
