/* $Id: strutl.cc,v 1.8 2001/03/10 14:55:44 ltd Exp $ */

#include <std.h>
#include <cstdarg>

/*
 * Remember to free this memory
 */
char *period_string(const char *string, unsigned count)
{
	char *Newstr = new char[count + 1];

	memcpy(Newstr, string, count);
	Newstr[count] = 0;

	return Newstr;
}		

void strlower(char * str)
{
	char *p;
	for (p=str; *p != '\0'; p++) *p = tolower(*p);
}

char *sane_strtok(char *s, const char *delim)
{
	static char *_s;
	char *p, *x;

	if (s != NULL)
		_s = s;

	if (_s == NULL)
		return NULL;

	if ((p = strstr(_s, delim)) == NULL)
	{
		p = _s;
		_s = NULL;
		return p;
	}
	x = _s;
	*p = 0;
	_s = ++p;
	return x;
}

/*
 * Assuming dest has enough memory to hold len bytes of src
 */
void sane_strntrnc(char *dest, const char *src, unsigned int len)
{
	if (strlen(src) < len)
	{
		memcpy(dest, src, strlen(src));
		dest[strlen(src)] = 0;
	}
	else
	{
		memcpy(dest, src, len);
		dest[len] = 0;
	}
}

/* 
 * returns a pointer to a static buffer with a copy of the origstr, with any
 * color codes removed. The caller should not free the returned string!
 */
 
char *stripcolorcodes(const char *origstr)
{
	static char retbuf[1024];
	const char *p = origstr;
	unsigned int i = 0;

	while (i < sizeof retbuf) {
		if (*p == '$' && *(p+1) != 0 && *(p+2) == '#') {
			p += 3;
			continue;
		}
		if (*p == '$' && *(p+1) == '!') {
			p += 2;
			continue;
		}
		retbuf[i] = *p;

		if (*p == 0) break;
		p++;
		i++;
	}

	return retbuf;
}

/*

int d_asprintf(char **buf, const char *fmt, ...)
{
	va_list va;
	int b_size = 0;
	int d;
	char c, *s;
	
	va_start(va, fmt);

	while (*fmt) 
	{
		if (*fmt == '%') 
		{
			switch (*++fmt)
			{
			case 's':
				s = va_arg(va, char *);
				*buf = realloc(*buf, b_size + strlen(s));
				memcpy(*buf + b_size, s, strlen(s));
				b_size += strlen(s);
				break;
			case 'd':
			case 'i':
				break;
			case 'c':
				c = (char) va_arg(va, int); 
				*buf = realloc(*buf, ++b_size);
				*(*buf + b_size - 1) = c;
				break;
			}
		}
		else
		{
			*buf = realloc(*buf, ++b_size)
			*(*buf + b_size - 1) = *fmt;
		}
	}

	*buf = realloc(*buf, ++b_size);
	*(*buf + b_size - 1) = 0;

	va_end(va);
}
*/
